//Sign Sounds
freeslot("sfx_goalri", "sfx_endlvl")
sfxinfo[sfx_goalri] = {flags = SF_X2AWAYSOUND,}
sfxinfo[sfx_endlvl] = {flags = SF_X2AWAYSOUND,}

//SA2 Sign
freeslot("SPR_GLRG", "SPR_GLR2")

local CV_GoalRingType = CV_RegisterVar({
name = "signtype",
defaultvalue = 0,
PossibleValue = {SA2=0, Heroes=1, SRB2=2}
})

local postsign
//Sign things
addHook("MobjThinker", function(sign)
	
	-- Set sign's scale
	-- GoalRing's actual height/radius
	sign.actualheight = 200*FRACUNIT
	sign.diameter = 90*FRACUNIT
	sign.height = 32*FRACUNIT
	sign.radius = 45*FRACUNIT
	
	-- Get original angle of signpost
	-- Only works if not a goalring on level load :<
	if sign.originalangle == nil
	and CV_GoalRingType.value == 2
		sign.originalangle = sign.angle
	end
	if sign.prespinangle == nil --Compatibility with SA-Sonic.
		sign.prespinangle = sign.angle
	end
	
	-- GoalRing sound timer
	if sign.goalsound == nil
	or sign.goalsound >= 25
		sign.goalsound = 0
	end

	-- Change Sign's sprites depending on CV value
	if sign.state == S_SIGN
	or sign.state >= S_SIGNSPIN1 and sign.state <= S_SIGNSPIN6
		if CV_GoalRingType.value == 2
			sign.sprite = SPR_SIGN
			sign.tracer.sprite = SPR_SIGN
			sign.tracer.tracer.sprite = SPR_SIGN
			sign.tracer.tracer.flags2 = $1 & ~MF2_DONTDRAW
			sign.info.painchance = MT_SPARK
		elseif CV_GoalRingType.value == 1
			sign.sprite = SPR_GLRG
			sign.tracer.sprite = SPR_GLRG
			sign.tracer.tracer.sprite = SPR_GLRG
			sign.tracer.tracer.flags2 = $1 & ~MF2_DONTDRAW
			sign.info.painchance = 0 -- Remove Sign's spin sparkle
		else
			sign.sprite = SPR_GLR2
			sign.tracer.sprite = SPR_GLR2
			sign.tracer.tracer.sprite = SPR_GLR2
			sign.info.painchance = 0 -- Remove Sign's spin sparkle
			if sign.goalsound == 16
				postsign = sign.tracer.tracer
				sign.tracer.tracer.flags2 = $1 | MF2_DONTDRAW -- "GOAL" flashing
			elseif sign.goalsound == 0
				sign.tracer.tracer.flags2 = $1 & ~MF2_DONTDRAW
			end
			if sign.tracer.tracer.state == S_EGGMANSIGN -- If "GOAL", make inner ring black instead of sign's default color "SKINCOLOR_CARBON"
				sign.tracer.color = SKINCOLOR_BLACK
			end
		end
	end
	
	if sign.state >= S_SIGN and sign.state <= S_CLEARSIGN
		if sign.sprite != SPR_SIGN
		or sign.tracer.sprite != SPR_SIGN
		or sign.tracer.tracer.sprite != SPR_SIGN
			sign.frame = $|FF_FULLBRIGHT
			sign.tracer.frame = $|FF_FULLBRIGHT
			sign.tracer.tracer.frame = $|FF_FULLBRIGHT
		else
			sign.frame = $1 & ~FF_FULLBRIGHT
			sign.tracer.frame = $1 & ~FF_FULLBRIGHT
			sign.tracer.tracer.frame = $1 & ~FF_FULLBRIGHT
		end
	end
	if not CV_GoalRingType.value --If SA2 goal ring...
		//Particle spin
		postsign = sign
		if (leveltime % 2 == 0)
			local signangle = sign.angle
			if signangle != 0
				signangle = $/ANG1
			end
			//sign.signSparkle = 0
			if sign.state ~= S_SIGN
				sign.signSparkle = P_SpawnMobj(sign.x, sign.y, sign.floorz + sign.height*2 + P_RandomRange(0, 100)*FRACUNIT, MT_IVSP)
			else
				sign.signSparkle = P_SpawnMobj(sign.x, sign.y, sign.floorz + sign.height*2 + P_RandomRange(0, 100)*FRACUNIT, MT_PARTICLE)
			end
			--Minor optimization.
			
			P_Thrust(sign.signSparkle, P_RandomRange(signangle, 360)*ANG1, P_RandomRange(1, 8)*FRACUNIT)
			P_SetObjectMomZ(sign.signSparkle, P_RandomRange(-5, 5)*FRACUNIT, true)
			P_SetScale(sign.signSparkle, sign.scale/2*FRACUNIT)
			sign.signSparkle.fuse = 32
			sign.signSparkle.blendmode = AST_ADD
			sign.signSparkle.colorized = true --This is how you color non-colorable sprites.
			sign.signSparkle.color = SKINCOLOR_SUPERGOLD5
			sign.signSparkle.frame = A|TR_TRANS80|FF_FULLBRIGHT
		end
	elseif CV_GoalRingType.value == 1
		local signangle = sign.angle
		if signangle != 0
			signangle = $/ANG1
		end
		sign.signSparkle = P_SpawnMobj(sign.x + P_RandomRange(45, -45)*FRACUNIT, sign.y + P_RandomRange(45, -45)*FRACUNIT, sign.z + sign.actualheight + P_RandomRange(-10,10)*FRACUNIT, MT_IVSP)
		P_Thrust(sign.signSparkle, P_RandomRange(signangle, 360)*ANG1, P_RandomRange(-4,4)*FRACUNIT)
		P_SetObjectMomZ(sign.signSparkle, P_RandomRange(-2,2)*FRACUNIT, false)
		P_SetScale(sign.signSparkle, sign.scale/2*FRACUNIT)
		sign.signSparkle.blendmode = AST_ADD
		sign.signSparkle.colorized = true
		sign.signSparkle.color = SKINCOLOR_SUPERGOLD5
		sign.signSparkle.frame = $|FF_TRANS40|FF_FULLBRIGHT
		sign.signSparkle.flags = $1 & ~MF_NOGRAVITY
		sign.signSparkle.fuse = P_RandomRange(15,35)*FRACUNIT
		postsign = sign
	elseif CV_GoalRingType.value == 2
		if sign.tracer and sign.tracer.tracer and sign.tracer.tracer.spriteyoffset == 8*FRACUNIT	
		sign.tracer.tracer.spriteyoffset = 0
		end
		S_StopSoundByID(sign, sfx_goalri)
		return 
	end
	
	if sign.tracer.sprite != SPR_PLAY and sign.tracer.frame < S
		sign.tracer.spriteyoffset = 0
	end
	
	-- If ceiling is shorter than GoalRing, change its scale
	if sign.ceilingz < (sign.actualheight + sign.floorz)
		P_SetScale(sign, FixedDiv((sign.ceilingz - sign.floorz)*2, sign.actualheight))
	else
		P_SetScale(sign, FixedDiv(4*FRACUNIT, 2*FRACUNIT))
	end
	
	-- GoalRing rotation
	if sign.valid
		-- GoalRing Swish
		if sign.goalpassedsound == nil
			sign.goalpassedsound = 0
		end	
		if sign.angleRotation == nil
			sign.angleRotation = 0
		end
		
		if sign.goalStarRotation == nil
			sign.goalStarRotation = 0
		end
		
		if sign.goalRedRingRotation == nil
			sign.goalRedRingRotation = 0
		end
		
		--Minor optimization.
		
		if sign.state == S_SIGN
			-- Ring rotation
			sign.angleRotation = ($ + 3) % 360
			sign.angle = FixedAngle(sign.angleRotation*FRACUNIT)				
		end

		if CV_GoalRingType.value == 1
			if sign.state >= S_SIGN and sign.state <= S_CLEARSIGN
				local signStarSpawned = 0 -- Heroes Center Star	
				if signStarSpawned == 0
				and sign.valid
					sign.signStar = P_SpawnMobj(sign.x, sign.y, sign.z, MT_THOK)
					sign.signStar.sprite = SPR_GLRG
					sign.signStar.frame = T|FF_FULLBRIGHT|FF_PAPERSPRITE
					sign.signStar.flags = sign.flags
					sign.signStar.flags2 = $1 & ~MF2_DONTDRAW
					sign.signStar.eflags = sign.eflags
					sign.signStar.scale = sign.scale
					sign.signStar.tics = 2
					signStarSpawned = 1
				end
				if signStarSpawned
				and sign.valid
					sign.goalStarRotation = ($ + 1) % 360
					sign.signStar.angle = FixedAngle(sign.goalStarRotation*FRACUNIT)
					P_SetScale(sign.signStar, sign.scale)
					P_TeleportMove(sign.signStar, sign.x, sign.y, sign.z, MT_THOK)
				end			
							
				local signRedRingSpawned = 0 -- Heroes Red Ring Thing
				if signRedRingSpawned == 0
				and sign.valid
					sign.signRedRing = P_SpawnMobj(sign.x, sign.y, sign.z, MT_THOK)
					sign.signRedRing.sprite = SPR_GLRG
					sign.signRedRing.frame = U|FF_FULLBRIGHT|FF_PAPERSPRITE
					sign.signRedRing.flags = sign.flags
					sign.signRedRing.flags2 = $1 & ~MF2_DONTDRAW
					sign.signRedRing.eflags = sign.eflags
					sign.signRedRing.scale = sign.scale
					sign.signRedRing.tics = 2
					signRedRingSpawned = 1
				end
				if signRedRingSpawned
					sign.goalRedRingRotation = ($ + 2) % 360
					sign.signRedRing.angle = FixedAngle(sign.goalRedRingRotation*FRACUNIT)
					sign.signRedRing.rollangle = FixedAngle(sign.goalRedRingRotation*FRACUNIT)
					P_SetScale(sign.signRedRing, sign.scale)
					P_TeleportMove(sign.signRedRing, sign.x, sign.y, sign.z)
				end
				if sign.target and sign.target.player and (sign.target.player.pflags & PF_FINISHED)
					sign.signRedRing.angle = sign.angle + ANGLE_90
					sign.signStar.angle = sign.angle + ANGLE_90
				end
			end
		end

		if (sign.state == S_SIGN)
			-- Goal Sound timer
			sign.goalsound = $1 + 1
		end	
		if sign.goalsound == 1
		and sign.state == S_SIGN and CV_GoalRingType.value != 2 --All but vanilla sign
			S_StartSoundAtVolume(sign, sfx_goalri, 150)
		end	
	//	for player in players.iterate --We won't need this, the sign targets a player for us!
		if sign.goalpassedsound == 0
		and sign.state == S_SIGNSPIN1
			S_StopSound(sign)
			S_StartSound(sign, sfx_endlvl)
			sign.goalpassedsound = 1
		end		
		if sign.spintimer == nil
		sign.spintimer = 0
		end
		sign.momz = 0
		sign.z = (sign.floorz + 1*FRACUNIT)
			
		if sign.target and sign.target.player and (sign.target.player.pflags & PF_FINISHED)
			sign.goalsound = 0
			sign.momz = sign.momz
			sign.spintimer = $1 + 1
		end
		if sign.spintimer >= 50
			sign.z = sign.floorz
			sign.spintimer = 50
		end
	end
end, MT_SIGN)

--PostThinkFrame to force animations...

addHook("PostThinkFrame", do
	if postsign 
		if postsign.valid
		--It's the pole sprite that gets in the way, so let's go nuclear.
			if postsign.state > S_SIGN and postsign.state <= S_CLEARSIGN
				if postsign.sprite == SPR_SIGN and postsign.frame == A
				postsign.flags2 = $|MF2_DONTDRAW
				end
				if postsign.tracer.sprite == SPR_SIGN and postsign.tracer.frame == A
				postsign.tracer.flags2 = $|MF2_DONTDRAW
				end
				if postsign.tracer.tracer.sprite == SPR_SIGN and postsign.tracer.tracer.frame == A
				postsign.tracer.tracer.flags2 = $|MF2_DONTDRAW
				end	
				
				if postsign.sprite != SPR_SIGN
				or postsign.tracer.sprite != SPR_SIGN
				or postsign.tracer.tracer.sprite != SPR_SIGN
					postsign.frame = $1|FF_FULLBRIGHT
					postsign.tracer.frame = $1|FF_FULLBRIGHT
					postsign.tracer.tracer.frame = $1|FF_FULLBRIGHT
				else
					postsign.frame = $1 & ~FF_FULLBRIGHT
					postsign.tracer.frame = $1 & ~FF_FULLBRIGHT
					postsign.tracer.tracer.frame = $1 & ~FF_FULLBRIGHT
				end
				
			end
			if postsign.tracer and postsign.tracer.tracer and (CV_GoalRingType.value != 2)
				if (postsign.tracer.tracer.sprite != SPR_GLRG and postsign.tracer.tracer.sprite != SPR_GLR2)
				postsign.tracer.tracer.spriteyoffset = 8*FRACUNIT --Go up higher, please
				else
				postsign.tracer.tracer.spriteyoffset = 0 --NVM!
				end
				if (postsign.tracer.tracer.sprite == SPR_PLAY)
				and postsign.tracer.tracer.skin == "adventuresonic" --Metalwario64 approved of this mod, so let me just sneak this in for you!
					postsign.tracer.tracer.sprite = SPR_GLR2		
					postsign.tracer.tracer.frame = S|FF_FULLBRIGHT|FF_PAPERSPRITE
					postsign.tracer.tracer.spriteyoffset = 0
				end
			end
		end
	postsign = nil
	end
end)